package org.omg.DynamicAny;

import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.portable.ObjectImpl;
import org.omg.CORBA.Object;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;

public abstract class DynUnionHelper
{
    private static String _id;
    private static TypeCode __typeCode;
    
    public DynUnionHelper() {
    }
    
    public static void insert(Any any, DynUnion dynUnion) {
        OutputStream create_output_stream = any.create_output_stream();
        any.type(type());
        write(create_output_stream, dynUnion);
        any.read_value(create_output_stream.create_input_stream(), type());
    }
    
    public static DynUnion extract(Any any) {
        return read(any.create_input_stream());
    }
    
    public static synchronized TypeCode type() {
        if (DynUnionHelper.__typeCode == null) {
            DynUnionHelper.__typeCode = ORB.init().create_interface_tc(id(), "DynUnion");
        }
        return DynUnionHelper.__typeCode;
    }
    
    public static String id() {
        return DynUnionHelper._id;
    }
    
    public static DynUnion read(InputStream inputStream) {
        throw new MARSHAL();
    }
    
    public static void write(OutputStream outputStream, DynUnion dynUnion) {
        throw new MARSHAL();
    }
    
    public static DynUnion narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof DynUnion)) {
            return (DynUnion)object;
        }
        if (!object._is_a(id())) {
            throw new BAD_PARAM();
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _DynUnionStub dynUnionStub = new _DynUnionStub();
        dynUnionStub._set_delegate(get_delegate);
        return dynUnionStub;
    }
    
    public static DynUnion unchecked_narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof DynUnion)) {
            return (DynUnion)object;
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _DynUnionStub dynUnionStub = new _DynUnionStub();
        dynUnionStub._set_delegate(get_delegate);
        return dynUnionStub;
    }
    
    static {
        DynUnionHelper._id = "IDL:omg.org/DynamicAny/DynUnion:1.0";
        DynUnionHelper.__typeCode = null;
    }
}
